# coding: utf-8

"""
    MONEI API v1

    <p>The MONEI API is organized around <a href=\"https://en.wikipedia.org/wiki/Representational_State_Transfer\">REST</a>. Our API has predictable resource-oriented URLs, accepts JSON-encoded request bodies, returns JSON-encoded responses, and uses standard HTTP response codes, authentication, and verbs.</p> <h4 id=\"base-url\">Base URL:</h4> <p><a href=\"https://api.monei.com/v1\">https://api.monei.com/v1</a></p> <h4 id=\"client-libraries\">Client libraries:</h4> <ul> <li><a href=\"https://github.com/MONEI/monei-php-sdk\">PHP SDK</a></li> <li><a href=\"https://github.com/MONEI/monei-python-sdk\">Python SDK</a></li> <li><a href=\"https://github.com/MONEI/monei-node-sdk\">Node.js SDK</a></li> <li><a href=\"https://postman.monei.com/\">Postman</a></li> </ul> <h4 id=\"important\">Important:</h4> <p><strong>If you are not using our official SDKs, you need to provide a valid <code>User-Agent</code> header in each request, otherwise your requests will be rejected.</strong></p>   # noqa: E501

    The version of the OpenAPI document: 1.4.3
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from Monei.configuration import Configuration


class ValidateBizumPhoneRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'account_id': 'str',
        'payment_id': 'str',
        'phone_number': 'str'
    }

    attribute_map = {
        'account_id': 'accountId',
        'payment_id': 'paymentId',
        'phone_number': 'phoneNumber'
    }

    def __init__(self, account_id=None, payment_id=None, phone_number=None, local_vars_configuration=None):  # noqa: E501
        """ValidateBizumPhoneRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._account_id = None
        self._payment_id = None
        self._phone_number = None
        self.discriminator = None

        self.account_id = account_id
        if payment_id is not None:
            self.payment_id = payment_id
        self.phone_number = phone_number

    @property
    def account_id(self):
        """Gets the account_id of this ValidateBizumPhoneRequest.  # noqa: E501

        MONEI Account identifier.  # noqa: E501

        :return: The account_id of this ValidateBizumPhoneRequest.  # noqa: E501
        :rtype: str
        """
        return self._account_id

    @account_id.setter
    def account_id(self, account_id):
        """Sets the account_id of this ValidateBizumPhoneRequest.

        MONEI Account identifier.  # noqa: E501

        :param account_id: The account_id of this ValidateBizumPhoneRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and account_id is None:  # noqa: E501
            raise ValueError("Invalid value for `account_id`, must not be `None`")  # noqa: E501

        self._account_id = account_id

    @property
    def payment_id(self):
        """Gets the payment_id of this ValidateBizumPhoneRequest.  # noqa: E501

        Unique identifier for the payment.  # noqa: E501

        :return: The payment_id of this ValidateBizumPhoneRequest.  # noqa: E501
        :rtype: str
        """
        return self._payment_id

    @payment_id.setter
    def payment_id(self, payment_id):
        """Sets the payment_id of this ValidateBizumPhoneRequest.

        Unique identifier for the payment.  # noqa: E501

        :param payment_id: The payment_id of this ValidateBizumPhoneRequest.  # noqa: E501
        :type: str
        """

        self._payment_id = payment_id

    @property
    def phone_number(self):
        """Gets the phone_number of this ValidateBizumPhoneRequest.  # noqa: E501

        Phone number in E.164 format.  # noqa: E501

        :return: The phone_number of this ValidateBizumPhoneRequest.  # noqa: E501
        :rtype: str
        """
        return self._phone_number

    @phone_number.setter
    def phone_number(self, phone_number):
        """Sets the phone_number of this ValidateBizumPhoneRequest.

        Phone number in E.164 format.  # noqa: E501

        :param phone_number: The phone_number of this ValidateBizumPhoneRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and phone_number is None:  # noqa: E501
            raise ValueError("Invalid value for `phone_number`, must not be `None`")  # noqa: E501

        self._phone_number = phone_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ValidateBizumPhoneRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ValidateBizumPhoneRequest):
            return True

        return self.to_dict() != other.to_dict()
